\chapter{Examples and Use Cases}
\label{cap:cases}
Will we exclusively talk about somewhere and oar related examples, in this part.

\section{Example 1 : I just want to do a simple experiment}
\label{example1}
This example is intended to people who wants to experiment right now. It can be used as a tutorial. \\
We will explain several things in this example:
\begin{itemize}
	\item Register useful programs
	\item Create an instance (list of peers)
	\item Create a list of queries 
	\item Create a deployment configuration
	\item Create an experience configuration
	\item Deploy and experiment !
	\item Export results and analysis
\end{itemize}

\subsection{Register useful programs}
In this part, we will register the external programs of interest, so that GExTools can use them. \\
We want :
\begin{itemize}
	\item A somewhere application (a solver)
	\item A somewhere answers Manager
	\item A generator of somewhere instance files (to have a list of peers we can experiment on)
\end{itemize}
To do that, we will have to enter three commands:
\begin{itemize}
	\item One for registering the somewhere application:
		\begin{lstlisting}  [style=bash]
			./gexProgs -n sol0 -r 1 register -p /path/to/solver  -t solver
		\end{lstlisting}  [style=bash]
		Here, \verb!sol0! is the name we want to call the somewhere application, \verb!1! is its version, and \verb!/path/to/solver! is the path to find it.
	\item One for registering the answers manager:
		\begin{lstlisting}  [style=bash]
			./gexProgs -n am0 -r 1 register -p /path/to/answersManager  -t answersManager
		\end{lstlisting}
		Here, \verb!am0! is the name we want to call the somewhere answers Manager, \verb!1! is its version, and \verb!/path/to/answersManager! is the path to find it.
	\item One for registering the instance generator:
		\begin{lstlisting}  [style=bash]
			./gexProgs -n g0 -r 1 register -p /path/to/generator  -t generator
		\end{lstlisting}
		Here, \verb!g0! is the name we want to call the somewhere instance generator, \verb!1! is its version, and \verb!/path/to/generator! is the path to find it.
\end{itemize}


\subsection{Generate an instance}
In this part, we will generate an instance of somewhere peers using the registered (just above, in the precedent section) instance generator. \\
Enter the following command :
\begin{lstlisting}  [style=bash]
./gexInstances -v -n newInstance -d "Barabassi instance. 100 peers with 2 fixed mappings each." -g swontogen -G 1.0 -f swr somewhere -s glucose -S 2.0 -N 100 --generatorType BARABASSI -p 70 -P 0.1 -m 2 -M 4 -d 2 -D 10 -t 70,10,10,0,10 -a NONCROSSING -F 2 -i 1 -e 2 -r 42
\end{lstlisting}
It will generate a new somewhere instance named \verb!newInstance!, with the generator named \verb!swontogen!, and of version \verb!1.0!, triggering the execution of the sat solver \verb!glucose! version \verb!2.0!. Other component specific arguments used were: $N=100$ peers, generated using a \verb!BARABASSI! algorithm, with $70$ literals per peers, $10$ percent of equivalent links, a number of branching between $2$ and $4$, a depth between $2$ and $10$, with the following mapping type distribution : 70\% ( ->),  10\% (<-),  10\% (disjoint), 10\% (equiv), 10\% (xor). It also uses a \verb!NONCROSSING! mappings generator type, with a number of mappings always equals to $2$, an initial number of peers (barabassi-specific option) equals to $1$, a number of edges to add per timestep (barabassi-specific option) equals to $2$, and a random seed number (barabassi-specific option) equals to $42$.


\subsection{Geneate a problem set}
In this part, we will generate a problem set related to the instance we just generated. \\
Enter the following command :
\begin{lstlisting}  [style=bash]
./gexProblems -n q0 generate -i i0 somewhere -t query -q 2 -p 0.5
\end{lstlisting}
It will generate a new somewhere queries set named \verb!q0!, related to the instance named \verb!i0!, with $2$ queries per peer, and $50$ percent probability to generate a negative query.


\subsection{Create a deployment configuration}
In this part, we want to register in the database the parameters related to the somewhere deployment we want to do in a Oar grid environment. \\
Enter the following command :
\begin{lstlisting}  [style=bash]
./gexDeploy -n dep0 register -p gdx:rdef=\"core=50\",sol:rdef=\"core=20\",bordemer:rdef=\"core=30\" 
\end{lstlisting}
It will register a new deployment configuration named \verb!dep0!, that will use $50$ processor cores on cluster \verb!gdx!, $20$ on cluster \verb!sol!, $30$ on cluster \verb!bordemer! . \\
If you use a login and password to connect to a specific grid host, you can also specify it. Note that, as the deployment system will use \verb!ssh! to connect, it is advised (and even required in some grid systems) that you add your public key on the \verb!~/.ssh/authorized_keys! file of the remote access ssh server. Moreover, it is usually a bad pratice to use password-only authentification (without public/private keys authentification).

\subsection{Create an experiment configuration}
In this part, we want to register in the database the parameters related to the somewhere experience we want to do. \\
Enter the following command :
\begin{lstlisting}  [style=bash]
./gexExperiments -n exp0 register -p problemSet0 -d dep0 somewhere -s sol0 -S 1 -a am0 -A 1
\end{lstlisting}
It will register a new experiment configuration named \verb!exp0!, that will use the instance \verb!i0!, the queries set \verb!q0!, 
the solver \verb!sol0!, of version $1$, the answer manager \verb!am0! of version $1$, the deployment \verb!dep0!, and we want to use \verb!Oar!. \\
When an experiment configuration is registered, you can executed it several times.

\subsection{Execute and experiment !}
Now that everything has been configured, and an experiment configuration is registered, we can launch it, i.e: ask the program to copy files on the grid, run the solvers, perform the queries and bring back (and save) the results.
In order to do that, enter the following command:
\begin{lstlisting}  [style=bash]
./gexExperiments -n exp0 execute somewhere -t 300
\end{lstlisting}
It should execute everything that is needed for the experiment. The component specific parameter \verb!-t! indicates the time-to-live of the query propagation on Somewhere. \\
\textbf{Important:} If the experiment needs to use different clusters, the option \emph{--vlan} needs to be used!
For large experiments, be prepared to wait a long time...


\section{Example 2 : I want to make several experiment executions and compare the results}
This example is intended to people who wants to just launch several experiments and compare
their results. \\
We will explain several things in this example (supposing that we have previously registered an experiment as explained on \ref{example1}):
\begin{itemize}
	\item Executing experiments and giving it a label
	\item Visualizing the execution result data.
	\item Comparing different experiments
	\item Comparing different executions of the same experiment
\end{itemize}

\subsection{Execute and experiment giving it a label}
In order to execute an experiment, the user needs to choose if he would like to give a special label for the execution in order to identify it in a easily way. By default, executions are labelled with the datetime when the execution was created.
In order to do that, enter the following command:
\begin{lstlisting}  [style=bash]
./gexExperiments -n exp0 execute -l mylabel
\end{lstlisting}
This execution of the experiment \emph{exp0} will be labelled with the label \emph{mylabel}. Now, the results of this execution can be analysed directly with the \emph{infos} command.

\subsection{Visualizing the execution data}
In order to visualizing the results and other useful information about an specific execution, the user call the infos command of the \emph{gexResults} program indicating the label of the execution that he would like to visualize.
In order to do that, enter the following command:
\begin{lstlisting}  [style=bash]
./gexResults -n exp0 infos -l mylabel
\end{lstlisting}
All result information collected for the execution \emph{mylabel} of the experiment \emph{exp0} will be fetched. If the user needs to visualize the result data from all executions of a given experiment, he simply needs to omit the label parameter on the \emph{infos} command.

\subsection{Comparing different experiments}
In this part, we want to compare the execution time of two or more different experiments. This action will generate average time and median time graphs of the selected experiments. This files will be created by default in your home directory.
In order to do that, enter the following command:
\begin{lstlisting}  [style=bash]
./gexResults -n exp0 compare -e exp1 exp2
\end{lstlisting}
More experiments can be added to the comparison just by adding its name into the \emph{--experiments} parameter.

\subsection{Comparing different executions of the same experiment}
In this part, we want to compare different executions of the same experiment. This action will generate average time and median time graphs of the selected executions of the indicated experiment. This files will be created by default in your home directory.
In order to do that, enter the following command:
\begin{lstlisting}  [style=bash]
./gexResults -n exp0 compare -x execution1 execution2
\end{lstlisting}
More experiments can be added to the comparison just by adding its name into the \emph{--executions} parameter.

\section{Example 3 : I want to use GExTools as an automated testing tool for continuous integration}
This can be done by integrating the GExTools as a Jenkins job. Your Jenkins must have enabled the \emph{ruby-runtime} plugin in order to run Ruby related jobs.\\
Another common task that could be imagined, would be to use GExTools to run integration tests of external tools (for example, Somewhere). However, this task is very user specific, depending of the tool and the component used to run experiments over this tool. \\
Nevertheless, this can be done by creating an integration test case that can be run by the GExTools from time to time. Again, there is no specific support for this task on GExTools but it can easily done, on each specific component, as a normal Ruby integration test.

\section{Example 4 : I want to make several experiments with several different DB servers and several different grids}
This can be done by indicating different \emph{database.yml} and \emph{config.yml} files during the registration/execution of experiments. The \emph{database.yml} file can indicate different databases were to store the experiment information and the \emph{config.yml} file can indicate different components to be used, including different grid components.

\subsection{How to indicate different configuration files during the registration/execution of experiments}
In order to indicate a different \emph{database.yml} file on any GExTools program, we need to use the \emph{--databaseConfigFile} parameter. The \emph{--componentConfigFile} can be used to indicate a different \emph{component.yml} configuration file. \\
By default, the \emph{database.yml} and \emph{component.yml} files will be used from the default GExTools configuration folder (\emph{.gextools}) located on your home directory.\\
Explanations about how to modify your configuration files to indicate another database or grid components can be find on \ref{confFiles}.

